#ifndef __schema_enum_h__
#define __schema_enum_h__
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */


typedef enum {
    QD_SCHEMA_ROUTER_MODE_STANDALONE,
    QD_SCHEMA_ROUTER_MODE_INTERIOR,
    QD_SCHEMA_ROUTER_MODE_EDGE,
    QD_SCHEMA_ROUTER_MODE_ENDPOINT,
    QD_SCHEMA_ROUTER_MODE_ENUM_COUNT
} qd_schema_router_mode_t;

extern const char *qd_schema_router_mode_names[QD_SCHEMA_ROUTER_MODE_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_LISTENER_ROLE_NORMAL,
    QD_SCHEMA_LISTENER_ROLE_INTER_ROUTER,
    QD_SCHEMA_LISTENER_ROLE_ON_DEMAND,
    QD_SCHEMA_LISTENER_ROLE_ENUM_COUNT
} qd_schema_listener_role_t;

extern const char *qd_schema_listener_role_names[QD_SCHEMA_LISTENER_ROLE_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_CONNECTOR_ROLE_NORMAL,
    QD_SCHEMA_CONNECTOR_ROLE_INTER_ROUTER,
    QD_SCHEMA_CONNECTOR_ROLE_ON_DEMAND,
    QD_SCHEMA_CONNECTOR_ROLE_ENUM_COUNT
} qd_schema_connector_role_t;

extern const char *qd_schema_connector_role_names[QD_SCHEMA_CONNECTOR_ROLE_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_LOG_MODULE_ROUTER,
    QD_SCHEMA_LOG_MODULE_ROUTER_HELLO,
    QD_SCHEMA_LOG_MODULE_ROUTER_LS,
    QD_SCHEMA_LOG_MODULE_ROUTER_MA,
    QD_SCHEMA_LOG_MODULE_MESSAGE,
    QD_SCHEMA_LOG_MODULE_SERVER,
    QD_SCHEMA_LOG_MODULE_AGENT,
    QD_SCHEMA_LOG_MODULE_CONTAINER,
    QD_SCHEMA_LOG_MODULE_CONFIG,
    QD_SCHEMA_LOG_MODULE_ERROR,
    QD_SCHEMA_LOG_MODULE_DISPATCH,
    QD_SCHEMA_LOG_MODULE_DEFAULT,
    QD_SCHEMA_LOG_MODULE_ENUM_COUNT
} qd_schema_log_module_t;

extern const char *qd_schema_log_module_names[QD_SCHEMA_LOG_MODULE_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_FIXEDADDRESS_FANOUT_MULTIPLE,
    QD_SCHEMA_FIXEDADDRESS_FANOUT_SINGLE,
    QD_SCHEMA_FIXEDADDRESS_FANOUT_ENUM_COUNT
} qd_schema_fixedAddress_fanout_t;

extern const char *qd_schema_fixedAddress_fanout_names[QD_SCHEMA_FIXEDADDRESS_FANOUT_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_FIXEDADDRESS_BIAS_CLOSEST,
    QD_SCHEMA_FIXEDADDRESS_BIAS_SPREAD,
    QD_SCHEMA_FIXEDADDRESS_BIAS_ENUM_COUNT
} qd_schema_fixedAddress_bias_t;

extern const char *qd_schema_fixedAddress_bias_names[QD_SCHEMA_FIXEDADDRESS_BIAS_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_ROUTER_LINK_LINKTYPE_ENDPOINT,
    QD_SCHEMA_ROUTER_LINK_LINKTYPE_WAYPOINT,
    QD_SCHEMA_ROUTER_LINK_LINKTYPE_INTER_ROUTER,
    QD_SCHEMA_ROUTER_LINK_LINKTYPE_INTER_AREA,
    QD_SCHEMA_ROUTER_LINK_LINKTYPE_ENUM_COUNT
} qd_schema_router_link_linkType_t;

extern const char *qd_schema_router_link_linkType_names[QD_SCHEMA_ROUTER_LINK_LINKTYPE_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_ROUTER_LINK_LINKDIR_IN,
    QD_SCHEMA_ROUTER_LINK_LINKDIR_OUT,
    QD_SCHEMA_ROUTER_LINK_LINKDIR_ENUM_COUNT
} qd_schema_router_link_linkDir_t;

extern const char *qd_schema_router_link_linkDir_names[QD_SCHEMA_ROUTER_LINK_LINKDIR_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_CONNECTION_STATE_CONNECTING,
    QD_SCHEMA_CONNECTION_STATE_OPENING,
    QD_SCHEMA_CONNECTION_STATE_OPERATIONAL,
    QD_SCHEMA_CONNECTION_STATE_FAILED,
    QD_SCHEMA_CONNECTION_STATE_USER,
    QD_SCHEMA_CONNECTION_STATE_ENUM_COUNT
} qd_schema_connection_state_t;

extern const char *qd_schema_connection_state_names[QD_SCHEMA_CONNECTION_STATE_ENUM_COUNT];


typedef enum {
    QD_SCHEMA_CONNECTION_DIR_IN,
    QD_SCHEMA_CONNECTION_DIR_OUT,
    QD_SCHEMA_CONNECTION_DIR_ENUM_COUNT
} qd_schema_connection_dir_t;

extern const char *qd_schema_connection_dir_names[QD_SCHEMA_CONNECTION_DIR_ENUM_COUNT];


#endif
